/*
 * Created on Jan 21, 2005
 */
package com.sunlabs.archsim.gasp;

import com.sunlabs.archsim.base.simulation.Delay;

/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * @author ib27688
 *
 * A template for a function. Similar to a command only that a command
 * execution does not return a value and function execution does.
 *
 */

public abstract class Function {
	
	/** a delay associated with the calculation of this function */
	protected Delay functionDelay;
	
	/** function name */
	protected String name;
	
	/** Code function evaluation here */
	public abstract Object value();
	
	/** construct a function with a default delay of zero */
	public Function(String n) {
		name= n;
		functionDelay= new Delay(0);
	}
	
	/** set the delay when constructing the function */
	public Function(String n, Delay d) {
		name= n;
		functionDelay= (Delay) (d.clone());
	}
	
	public Delay getDelay() {
		// return a clone so that the original is not touched
		return (Delay)(functionDelay.clone());
	}
	
	public void setDelay(Delay d) {
		functionDelay= (Delay) d.clone();
	}
	
	public String getName() {
		return name;
	} // getName
	
} // Function
